package com.example.unai.gal;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.BatteryManager;
import android.util.Log;

import java.util.Calendar;
import java.util.Map;

import app.akexorcist.bluetotohspp.library.BluetoothSPP;
import app.akexorcist.bluetotohspp.library.BluetoothState;

import static android.os.SystemClock.sleep;

/**
 * Created by Unai on 13/08/2015.
 */
public class AlarmService extends BroadcastReceiver {
    private IntentFilter ifilter;
    private Intent batteryStatus;
    private boolean bluen = false;

    @Override
    public void onReceive(Context context, Intent intent) {
        Log.i("Alarm Receiver ", "Message recieved");
        //Bateria Informazioa
        ifilter = new IntentFilter(Intent.ACTION_BATTERY_CHANGED);
        batteryStatus = context.registerReceiver(null, ifilter);

        //Notifikazio informazioa
        final String s;
        int bat=0;
        String appName = "";
        int notifCant = 0;
        String notiText = "";
        String orduoso;
        Calendar c = Calendar.getInstance();
        int ordua = c.get(Calendar.HOUR_OF_DAY);
        int minutu = c.get(Calendar.MINUTE);
        Log.i("Ordua", "Ordua: "+ordua+" Minutua: "+minutu);
        if(ordua<10){
            orduoso = "0"+Integer.toString(ordua);
        }else{
            orduoso= Integer.toString(ordua);
        }
        //notifikazioaren informazioa lortu
        SharedPreferences data = context.getSharedPreferences("NotifInfo", 0);
        String restoredText = data.getString("appName", "");
        if (!restoredText.equals("")) {
            appName = data.getString("appName", "");//"No name defined" is the default value.
            notiText  = data.getString("appText", ""); //0 is the default value.
            notifCant  = data.getInt("notifCant", 0); //0 is the default value.

        }
        //bateriaren informazioa lortu
        int level = batteryStatus.getIntExtra(BatteryManager.EXTRA_LEVEL, -1);
        int scale = batteryStatus.getIntExtra(BatteryManager.EXTRA_SCALE, -1);

        float batteryPct = level / (float)scale;
        bat = (int) Math.ceil(batteryPct*100);
        if(notiText.length()>20){
            s = "@"+appName+"|"+notiText.substring(0,20)+"~#"+notifCant+"#"+bat+"%";
            Log.i("Alarm Receiver ", "Info to send: "+s);
        }else{
            s = "@"+appName+"|"+notiText+"~#"+notifCant+"#"+bat+"%"+orduoso+"&"+minutu+"&";
            Log.i("Alarm Receiver ", "Info to send: "+s);
        }



        //bluetooth spp prodecure
        SharedPreferences data2 = context.getSharedPreferences("BluInfo", Context.MODE_MULTI_PROCESS);
        String mac = data2.getString("adapter", "");
        Log.i("bluinfo",mac + "\n");
        final BluetoothSPP bt = new BluetoothSPP(context);

        if(!bt.isBluetoothEnabled()) {
            bt.enable();
            // Do somthing if bluetooth is disable
        } else {
            bluen = true;
            // Do something if bluetooth is already enable
        }

        bt.setupService();
        bt.startService(BluetoothState.DEVICE_OTHER);

        bt.setBluetoothConnectionListener(new BluetoothSPP.BluetoothConnectionListener() {
            public void onDeviceConnected(String name, String address) {
                // Do something when successfully connected
                Log.i("bluetoothCon", "Bluetooth connected");
                bt.send(s, false);
                bt.disconnect();
            }

            public void onDeviceDisconnected() {
                // Do something when connection was disconnected
                Log.i("bluetoothCon", "Device Desconected");
                bt.stopService();
            }

            public void onDeviceConnectionFailed() {
                // Do something when connection failed
                Log.i("bluetoothCon", "Bluetooth connection failed");
                bt.disconnect();
            }
        });
        bt.connect(mac);

    }




}
