#include <SoftwareSerial.h>
#include "U8glib.h"
 
SoftwareSerial bluetooth(10, 11); // Rx bluetooth(1), Tx bluetooth(2)
int comando;
char programa[50];
int iProg; 
char mensaje[256];
int iMen;
int modoMen;
int modoNot;
char notifcant[4];
char iNot;
int modoBat;
char bateria[5];
int iBat;
int modoEnd;
uint8_t draw_state;
int itxaron;
char ordu[2];
int iOrd;
char minutu[2];
int iMin;
int modotime;
int buttonState = 0;
int lastButtonState = 0;
//pantalla
//U8GLIB_DOGM128_2X u8g(7, 6, 5, 4);    // SPI Com: SCK = 7, MOSI = 6, CS = 5, A0 = 4
U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE|U8G_I2C_OPT_DEV_0);

void u8g_prepare(void) {
  u8g.setFont(u8g_font_6x10);
  u8g.setFontRefHeightExtendedText();
  u8g.setDefaultForegroundColor();
  u8g.setFontPosTop();
}



void notifpant(void) {
  u8g.setFont(u8g_font_unifont);
  u8g.setFont(u8g_font_baby);
  u8g.drawStr(50, 15, "Bateria: ");
  u8g.drawStr(90, 15, bateria);
  u8g.setFont(u8g_font_5x7);
  u8g.drawStr( 0, 15, "Noti:");
  u8g.drawStr( 25, 15, notifcant);
  u8g.setFont(u8g_font_6x10);
  u8g.drawStr( 10, 30, programa);
  u8g.setFont(u8g_font_baby);
  u8g.drawStr( 15, 45, mensaje);
  u8g.setFont(u8g_font_6x10);
}

void ordua(void) {
  u8g.setFont(u8g_font_fub20);
  u8g.drawStr(25, 40, ordu);
  u8g.drawStr(55, 37, ":");
  u8g.drawStr(65, 40, minutu);
  u8g.setFont(u8g_font_6x10);
}

void draw(void) {
  u8g_prepare();
  switch(draw_state) {
    case 0: ordua(); break;
    case 1: notifpant(); break;
    }
}
void setup() {
  Serial.begin(115200);
  Serial.println("LEDNotif Starting");
  pinMode(2, OUTPUT);     
  //honek botoia irakurriko du
  pinMode(13, INPUT);      
  digitalWrite(2, HIGH); 
  //u8g.setRot180();   
  int i;
  
  for (i = 0; i < 20; i = i + 1) {
    programa[i]=' ';
  }
  for (i = 0; i < 255; i = i + 1) {
   mensaje[i]=' ';
  }
  for (i = 0; i < 4; i = i + 1) {
   notifcant[i]=' ';
  }
  for (i = 0; i < 5; i = i + 1) {
   bateria[i]=' ';
  }
  modoMen=0;
  iMen=0;
  iProg=0;
  comando=0;
  modoNot=0;
  modoBat=0;
  modoEnd=0;
  iNot=0;
  iBat=0;
  itxaron =0;
  draw_state=1;
  iOrd=0;
  iMin=0;
  modotime=0;
  itxaron=1;
  ordu[0]='0';
  ordu[1]='0';
  minutu[0]='0';
  minutu[1]='0';
  
  //Serial1.begin(9600);
  
  delay(5000);
 
  bluetooth.begin(115200); 
  // 115200 can be too fast at times for SWserial to relay the data reliably
  bluetooth.print(F("$$$"));  // Enter command mode
  delay(100);  
  bluetooth.println(F("U,9600,N"));  // Temporarily change the baudrate to 9600, no parity
  delay(100);
  bluetooth.println(F("---"));
  bluetooth.begin(9600); 
  
  pinMode(7, OUTPUT); 
  digitalWrite(7, HIGH);  
  Serial.println("LEDNotif Ready");
}
 
void loop() {
   buttonState = digitalRead(13);
if(buttonState != lastButtonState){
   if(buttonState == HIGH){
    
  Serial.println("Botoia Sakaru da");
    delay(100);
    if(draw_state == 1){
      draw_state=0;
    }else{
      draw_state=1;
    }
   }
}
  buttonState = lastButtonState;
  char dataFromBT;
    u8g.firstPage(); 
  do {
    draw();
  } while( u8g.nextPage() );
  
  if(bluetooth.available()>0) {
    dataFromBT = bluetooth.read();
    Serial.println(dataFromBT);

    
if(modotime == 2){
  if(dataFromBT == '&'){
     Serial.print("Programa: ");
      Serial.print(programa);
      Serial.print(" Mensaje: ");
      Serial.println(mensaje); 
      Serial.print(" Notificant: ");
      Serial.println(notifcant); 
      Serial.print(" Bateria: ");
      Serial.println(bateria); 
      Serial.print(" Ordua: ");
      Serial.println(ordu); 
      Serial.print(" Minutuak: ");
      Serial.println(minutu); 
    Serial.println("modotime = 0");
    Serial.println("itxaron = 1");    
      itxaron = 1;
    iMin=0;
    modotime=0;
     digitalWrite(2, LOW); 
      delay(1000);
      digitalWrite(2, HIGH); 
  }else{
    minutu[iMin]=dataFromBT;
      iMin ++; 
  }
}

if(modotime == 1){
  if(dataFromBT == '&'){
    Serial.println("modotime = 2");
    modotime=2;
    iOrd=0;
  }else{
    ordu[iOrd]=dataFromBT;
      iOrd ++; 
  }
}

if(modoBat == 1){
    if(dataFromBT == '%'){
      bateria[iBat]=dataFromBT;     
      modoBat=0;
      Serial.println("modoBat = 0");     
      iBat=0;       
      Serial.println("modotime = 1");
      modotime = 1;     

    } else {         
      bateria[iBat]=dataFromBT;
      iBat ++; 
    }        
  }


  if(modoNot == 1){
    if(dataFromBT == '#'){
      modoBat=1;
      Serial.println("modoBat = 1");       
      modoNot=0;
      Serial.println("modoNot = 0");     
      iNot=0;         
    } else {         
      notifcant[iNot]=dataFromBT;
      iNot ++; 
    }        
  }
     
    
    if(modoMen == 1){

        
        if(modoEnd == 1){
          if(dataFromBT == '#'){
            mensaje[iMen]=' ';  
            modoNot=1;   
            Serial.println("modoNot = 1");       
            iMen=0;
            modoMen=0;
            Serial.println("modoMen = 0");                
            
          }else{
             iMen ++;
            modoEnd=0;
          }
        }
        if(modoEnd == 0){
          if(dataFromBT == '~'){
            mensaje[iMen]=dataFromBT;
            modoEnd=1;            
          } else {         
            mensaje[iMen]=dataFromBT;
            iMen ++; 
          }        
        }
      }
    
    if(comando==1){
     
    
      if(dataFromBT == '|') {        
        Serial.println("hasi |");          
        iProg = 0;        
        modoMen = 1;
        Serial.println("mensaje = 1"); 
        comando = 0;
        Serial.println("comando = 0"); 
        Serial.print("amaitu ");  
      } else {
        programa[iProg]=dataFromBT;
        iProg ++;
      }
  
    }
    if(itxaron == 1){
      
          if(dataFromBT == '@') {
            // Turn on LED
            itxaron=0;
            comando = 1;
            Serial.println("comando = 1");    
             int i=0;
          for (i = 0; i < 20; i = i + 1) {
            programa[i]=' ';
          }
          for (i = 0; i < 255; i = i + 1) {
           mensaje[i]=' ';
          }
          for (i = 0; i < 4; i = i + 1) {
           notifcant[i]=' ';
          }
          for (i = 0; i < 5; i = i + 1) {
           bateria[i]=' ';
          }
          }
      }   
  }
    
  
  
  }


